
# -*- coding: utf8 -*-
#
# Copyright (C) 2009 Jannik Heller <scrawl@baseoftrash.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.

#
# dBus mainloop fix , 2012-03-26 Jarek

import rhythmdb, rb
import dbus.mainloop.glib
import os
from gettext import *

class ScreenSaver(rb.Plugin):
	def __init__(self):
		rb.Plugin.__init__(self)

	def activate (self, shell):
                print("WHERE\n")
		self.shell = shell
		self.player = shell.get_player ()
                self.loop = dbus.mainloop.glib.DBusGMainLoop(set_as_default = True)
                self.bus = dbus.SessionBus(private=True,mainloop=self.loop)
                self.bus.add_signal_receiver(self.play_pause,'ActiveChanged','org.gnome.ScreenSaver')

                self.active = 1
                self.was_playing = 0

	def play_pause(self, arg):
		if self.active:
			if arg:
				# screensaver activated
				self.was_playing = self.player.get_playing()
				self.player.pause()
			else:
				# ...
				# only resume playback if rb was playing when screensaver activated
				if self.was_playing:
					self.player.play()

	def deactivate(self, shell):
		self.active = 0


